<%@ Assembly Name="MODIG200911, Version=1.0.0.0, Culture=neutral, PublicKeyToken=c3fb5f1b6adf5cc0" %>
<%@ Assembly Name="Microsoft.Web.CommandUI, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %> 
<%@ Register Tagprefix="SharePoint" Namespace="Microsoft.SharePoint.WebControls" Assembly="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %> 
<%@ Register Tagprefix="Utilities" Namespace="Microsoft.SharePoint.Utilities" Assembly="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Register Tagprefix="asp" Namespace="System.Web.UI" Assembly="System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35" %>
<%@ Import Namespace="Microsoft.SharePoint" %> 
<%@ Register Tagprefix="WebPartPages" Namespace="Microsoft.SharePoint.WebPartPages" Assembly="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="CAMLSearcherUserControl.ascx.cs" Inherits="MODIG200911.CAMLSearcher.CAMLSearcherUserControl" %>
<SharePoint:ScriptLink ID="ScriptLink1" runat="server" Name="sp.js" Localizable="false" LoadAfterUI="true"  />

<script src="http://ajax.microsoft.com/ajax/jquery/jquery-1.3.2.min.js" type="text/javascript"></script> 
<script type="text/javascript">

    function onQuerySucceeded(sender, args) {
        alert('Title: ' + this.oWebsite.get_title() + ' Decription: ' + this.oWebsite.get_description());
    }

    function onQueryFailed(sender, args) {
        alert('request failed ' + args.get_message() + '\n' + args.get_stackTrace());
    }

    function retrieveWebSite() {
        var clientContext = new SP.ClientContext.get_current();

        this.oWebsite = clientContext.get_web();
        var oList = oWebsite.get_lists().getByTitle('Tasks');
        var camlQuery = new SP.CamlQuery(); camlQuery.set_viewXml('<View><Query><Where><Geq><FieldRef Name=\'ID\'/>' + '<Value Type=\'Number\'>1</Value></Geq></Where></Query><RowLimit>10</RowLimit></View>');
        this.collListItem = oList.getItems(camlQuery);

        clientContext.load(this.oWebsite);
        clientContext.executeQueryAsync(Function.createDelegate(this, this.onQuerySucceeded), Function.createDelegate(this, this.onQueryFailed));
    }

    function dumpProps(obj) {
        for (var i in obj) {
            writeDebug(i + "<BR>");
            //if (typeof obj[i] == "object") {

        }
    }

    function writeDebug(msg) {
        var dbg = document.getElementById('debugDiv');
        dbg.innerHTML += msg;
    }

    function runCode() {
        eval(document.getElementById('txtArea').value);
    }

    function retrieveSpecificListPropertiesToCollection() {

        var clientContext = new SP.ClientContext.get_current();
        var oWebsite = clientContext.get_web();
        var collList = oWebsite.get_lists();

        this.listInfoCollection = clientContext.loadQuery(collList, 'Include(Title)');

        clientContext.executeQueryAsync(Function.createDelegate(this, this.onListsRetrievedSuccess), Function.createDelegate(this, this.onQueryFailed));
    }

    function onListsRetrievedSuccess() {
        //var data = "Core Selectors Attributes Traversing Manipulation CSS Events Effects Ajax Utilities".split(" ");
        var listInfo = '';
        for (var i = 0; i < this.listInfoCollection.length; i++) {
            var oList = this.listInfoCollection[i];
            //listInfo += ' ' + oList.get_title() ;
            $('#ddlLists').append("<OPTION>"+oList.get_title()+"</OPTION>");
        }

        //$("#txtList").autocomplete(listInfo.split(" "));
    }


    function onFieldsRetrievedSuccess() {
        for (var i = 0; i < this.fields.get_count(); i++) {
            $('#fieldList').append(this.fields.itemAt(i).get_internalName() + '<br />');
        }
    }

    function populateFields() {
        var clientContext = new SP.ClientContext.get_current();
        this.currentList = clientContext.get_web().get_lists().getByTitle($('#ddlLists').val());
        this.fields = currentList.get_fields();

        clientContext.load(this.fields);
        clientContext.executeQueryAsync(Function.createDelegate(this, this.onFieldsRetrievedSuccess), Function.createDelegate(this, this.onQueryFailed));

    }

    function onCAMLSuccess() {
        var listItemEnumerator = collListItem.getEnumerator();

        while (listItemEnumerator.moveNext()) {
            var oListItem = listItemEnumerator.get_current();
            $('#resultsDiv').append('ID: ' + oListItem.get_id() + 'Display name: ' + oListItem.get_displayName()); //+ ' ' + oListItem.get_fieldValues()['Department'] +  '<br>');

            // Display any additional Fields
            if ($("#txtFields").val().length > 0) {
                var fields = $("#txtFields").val().substring(1).split(',');
                for (var i=0; i < fields.length; i++) {
                    $('#resultsDiv').append(' ' + fields[i] + ': ' + oListItem.get_fieldValues()[fields[i]]);
                }               
            }
            $('#resultsDiv').append('<br />');
        }
    }

    function queryCAML() {
        var clientContext = new SP.ClientContext.get_current();
        var camlQuery = new SP.CamlQuery();
        camlQuery.set_viewXml($('#txtCAML').val());
        this.currentList = clientContext.get_web().get_lists().getByTitle($('#ddlLists').val());
        this.collListItem = this.currentList.getItems(camlQuery);

        var includeString;
        if ($("#txtFields").val().length > 0)
            includeString = 'Include(Id,DisplayName' + $("#txtFields").val() + ')';
        else
            includeString = 'Include(Id,DisplayName)';
        clientContext.load(collListItem, includeString);     
        clientContext.executeQueryAsync(Function.createDelegate(this, this.onCAMLSuccess), Function.createDelegate(this, this.onQueryFailed));
    }
    

    $(document).ready(function () {
        //var data = "Core Selectors Attributes Traversing Manipulation CSS Events Effects Ajax Utilities".split(" ");
        //$("#txtList").autocomplete(data);
        retrieveSpecificListPropertiesToCollection();
    });

    
      </script>        
 
      
      List: <select id="ddlLists" >
        <option></option>
      </select>
      <input type="button" onclick="javascript:populateFields()"  value="Populate Fields" /> <br />            
      <div id='fieldList'></div> <br />
      View Fields (Comma Separate): <input type="text" id="txtFields"  /> <br />
      CAML: <textarea id='txtCAML' cols='100' rows='15'>&lt;View&gt;&lt;RowLimit&gt;100&lt;/RowLimit&gt;&lt;/View&gt;</textarea><input type="button" onclick="javascript:queryCAML()"  value="Query" />
      <div id='resultsDiv'></div>
      
      <div id='debugDiv'></div>

      
      
